''' $Header:$
''' 
''' $Log:$
.de Sh
.br
.ne 5
.PP
\fB\\$1\fR
.PP
..
.de Sp
.if t .sp .5v
.if n .sp
..
'''
'''     Set up \*(-- to give an unbreakable dash;
'''     string Tr holds user defined translation string.
'''     Bell System Logo is used as a dummy character.
'''
.ie n \{\
.tr \(bs-\*(Tr
.ds -- \(bs-
.if (\n(.H=4u)&(1m=24u) .ds -- \(bs\h'-12u'\(bs\h'-12u'-\" diablo 10 pitch
.if (\n(.H=4u)&(1m=20u) .ds -- \(bs\h'-12u'\(bs\h'-8u'-\" diablo 12 pitch
.ds L" ""
.ds R" ""
.ds L' '
.ds R' '
'br\}
.el\{\
.ds -- \(em\|
.tr \*(Tr
.ds L" ``
.ds R" ''
.ds L' `
.ds R' '
'br\}
.TH EDACL 1 LOCAL
.SH NAME
edacl - edit the access control lists for files
.SH SYNOPSIS
.B edacl
file ...
.SH DESCRIPTION
.I edacl
edits the access control lists for one or more files.  The access control list
and the file's ownership are used to determine which users can access
the file.
.PP
For each file,
.I edacl
invokes the editor of your choice on the access control list of that file.
The first line has the name of the file whose acl is being edited.
The following lines contain the acl entries.  
.PP
Each acl entry has three fields.  The first field is either the string "user"
or "group".
The second field is a user or group name;  which it is depends on the
value of the first field.  The last field is the mode granted to that
user or group.  It is a single digit in the range [0-7],
indicating read-write-execute permission ala
.IR chmod .
.PP
You may add, change, or delete entries.  Upon exiting the editor,
.I edacl
will ask you if you wish to update the acl for that file.
.SH DIAGNOSTICS
.I edacl
calls
.I lsacl(1)
and
.I chacl(1)
to do the dirty work;  see the DIAGNOSTICS sections in their documentation.
.SH ENVIRONMENT VARIABLES
If the EDITOR variable is set,
.I edacl
assumes it contains the name of your desired editor.  Otherwise,
.I edacl
will ask you which one to use.
.SH SEE ALSO
chacl(1),
cpacl(1),
lsacl(1),
getacl(2),
setacl(2)
.SH CAVEAT
The implementation of access control lists is an experiment.  This
implementation stores the access control list in a (formerly) unused field
in the inode.
There is no guarantee that future versions of Unix will not use this field
for something else.
.PP
Therefore, you should only use access control lists with the full
understanding that you are participating in an experiment.
.SH BUGS
The entire mechanism hasn't been fully tested.
.PP
It might be nice if the mode were given symbolically ("rwx" instead
of "7").
